'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsTransitionGroup = require('react-addons-transition-group');

var _reactAddonsTransitionGroup2 = _interopRequireDefault(_reactAddonsTransitionGroup);

var _AppBar = require('material-ui/AppBar');

var _AppBar2 = _interopRequireDefault(_AppBar);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _close = require('material-ui/svg-icons/navigation/close');

var _close2 = _interopRequireDefault(_close);

var _FullscreenDialogFrame = require('./FullscreenDialogFrame');

var _FullscreenDialogFrame2 = _interopRequireDefault(_FullscreenDialogFrame);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getStyles = function getStyles(props, theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column'
    },
    title: {
      fontSize: 20,
      fontWeight: 500
    },
    appBar: {
      height: (props.appBarStyle ? props.appBarStyle.height : null) || theme.appBar.height
    },
    container: {
      flex: 1,
      overflow: 'auto',
      padding: 16
    }
  };
};

var FullscreenDialog = function (_Component) {
  _inherits(FullscreenDialog, _Component);

  function FullscreenDialog() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FullscreenDialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FullscreenDialog.__proto__ || Object.getPrototypeOf(FullscreenDialog)).call.apply(_ref, [this].concat(args))), _this), _this.onPopState = function (_ref2) {
      var state = _ref2.state;

      history.pushState(_this.id, 'popup');
      if (state === _this.id && _this.props.onRequestClose) {
        _this.props.onRequestClose();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FullscreenDialog, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.id = 'popup-' + Date.now();
      if (this.props.open) {
        history.replaceState(this.id, 'popup');
        history.pushState(this.id, 'popup');
      }
      window.addEventListener('popstate', this.onPopState);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('popstate', this.onPopState);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref3) {
      var open = _ref3.open;

      if (open && !this.props.open) {
        history.replaceState(this.id, 'popup');
        history.pushState(this.id, 'popup');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var styles = getStyles(this.props, this.context.muiTheme);

      var _props = this.props,
          actionButton = _props.actionButton,
          appBarStyle = _props.appBarStyle,
          children = _props.children,
          closeIcon = _props.closeIcon,
          containerStyle = _props.containerStyle,
          open = _props.open,
          style = _props.style,
          title = _props.title,
          titleStyle = _props.titleStyle;


      return _react2.default.createElement(
        _FullscreenDialogFrame2.default,
        {
          open: open,
          style: _extends({}, style, styles.root)
        },
        _react2.default.createElement(_AppBar2.default, {
          title: title,
          titleStyle: _extends({}, styles.title, titleStyle),
          style: _extends({}, styles.appBar, appBarStyle),
          iconElementLeft: _react2.default.createElement(
            _IconButton2.default,
            { onTouchTap: function onTouchTap() {
                return _this2.props.onRequestClose();
              } },
            closeIcon || _react2.default.createElement(_close2.default, null)
          ),
          iconElementRight: actionButton
        }),
        _react2.default.createElement(
          'div',
          { style: _extends({}, styles.container, containerStyle) },
          this.props.children
        )
      );
    }
  }]);

  return FullscreenDialog;
}(_react.Component);

exports.default = FullscreenDialog;


FullscreenDialog.propTypes = {
  actionButton: _react.PropTypes.node,
  appBarStyle: _react.PropTypes.object,
  children: _react.PropTypes.node,
  closeIcon: _react.PropTypes.node,
  containerStyle: _react.PropTypes.object,
  onRequestClose: _react.PropTypes.func,
  open: _react.PropTypes.bool.isRequired,
  style: _react.PropTypes.object,
  title: _react.PropTypes.string
};

FullscreenDialog.contextTypes = {
  muiTheme: _react.PropTypes.object
};