'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsTransitionGroup = require('react-addons-transition-group');

var _reactAddonsTransitionGroup2 = _interopRequireDefault(_reactAddonsTransitionGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getStyles = function getStyles(props) {
  return {
    root: {
      width: '100vw',
      height: '100vh',
      position: 'fixed',
      top: 0,
      left: 0,
      zIndex: 1500,
      background: '#fafafa'
    }
  };
};

var TransitionItem = function (_Component) {
  _inherits(TransitionItem, _Component);

  function TransitionItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TransitionItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TransitionItem.__proto__ || Object.getPrototypeOf(TransitionItem)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      style: {
        opacity: 0,
        transition: 'all 225ms cubic-bezier(0.0, 0.0, 0.2, 1)',
        transform: 'translate(0, 56px)'
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TransitionItem, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.enterTimeout);
      clearTimeout(this.leaveTimeout);
    }
  }, {
    key: 'componentWillEnter',
    value: function componentWillEnter(callback) {
      this.componentWillAppear(callback);
    }
  }, {
    key: 'componentWillAppear',
    value: function componentWillAppear(callback) {
      var _this2 = this;

      this.enterTimeout = setTimeout(function () {
        _this2.setState({
          style: {
            opacity: 1,
            transition: 'all 225ms cubic-bezier(0.0, 0.0, 0.2, 1)',
            transform: 'translate(0, 0px)'
          }
        });
        _this2.enterTimeout = setTimeout(callback, 225); // matches transition duration
      });
    }
  }, {
    key: 'componentWillLeave',
    value: function componentWillLeave(callback) {
      this.setState({
        style: {
          opacity: 0,
          transition: 'all 195ms cubic-bezier(0.4, 0.0, 1, 1)',
          transform: 'translate(0, 56px)'
        }
      });

      this.leaveTimeout = setTimeout(callback, 195); // matches transition duration
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          children = _props.children,
          other = _objectWithoutProperties(_props, ['style', 'children']);

      return _react2.default.createElement(
        'div',
        _extends({}, other, { style: _extends({}, style, this.state.style) }),
        children
      );
    }
  }]);

  return TransitionItem;
}(_react.Component);

TransitionItem.propTypes = {
  children: _react.PropTypes.node,
  style: _react.PropTypes.object
};

var FullscreenDialogFrame = function (_Component2) {
  _inherits(FullscreenDialogFrame, _Component2);

  function FullscreenDialogFrame() {
    _classCallCheck(this, FullscreenDialogFrame);

    return _possibleConstructorReturn(this, (FullscreenDialogFrame.__proto__ || Object.getPrototypeOf(FullscreenDialogFrame)).apply(this, arguments));
  }

  _createClass(FullscreenDialogFrame, [{
    key: 'render',
    value: function render() {
      var styles = getStyles(this.props);

      var _props2 = this.props,
          children = _props2.children,
          style = _props2.style,
          title = _props2.title,
          titleStyle = _props2.titleStyle;


      return _react2.default.createElement(
        _reactAddonsTransitionGroup2.default,
        {
          component: 'div',
          transitionAppear: true,
          transitionAppearTimeout: 225,
          transitionEnter: true,
          transitionEnterTimeout: 225
        },
        this.props.open && _react2.default.createElement(
          TransitionItem,
          { style: _extends({}, styles.root, style)
          },
          this.props.children
        )
      );
    }
  }]);

  return FullscreenDialogFrame;
}(_react.Component);

exports.default = FullscreenDialogFrame;


FullscreenDialogFrame.propTypes = {
  children: _react.PropTypes.node,
  open: _react.PropTypes.bool.isRequired,
  style: _react.PropTypes.object
};